;================================================================================================
;
; NAKORURU'S BASIC MOVES STATES
;
;================================================================================================

; Stance
;-------

[Statedef 0]
Type = S
MoveType = I
Physics = S

[State 0, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 0, 4)

[State 0, normal stance]
type = ChangeAnim
triggerall = var(0) = 0
triggerall = !win
trigger1 = Anim != 0 && Anim != 5
trigger2 = Anim = 5 && AnimTime = 0
value = 0

[State 0, pre-win stance]
type = ChangeAnim
triggerall = var(0) = 0
trigger1 = win
value = 180

[State 0, Sikuruu turn]
type = ChangeAnim
triggerall = var(0) = 20
trigger1 = Anim != 8005 && Anim = 5
value = 8005

[State 0, Sikuruu stance]
type = ChangeAnim
triggerall = var(0) = 20
trigger1 = Anim != 8000 && Anim != 8005 && Anim != 5
trigger2 = Anim = 8005 && AnimTime = 0
value = 8000

[State 0, velset]
type = VelSet
trigger1 = Time = 0
y = 0

[State 0, velset] ; stop moving if low velocity or 4 ticks pass
type = VelSet
trigger1 = abs(vel x) < 2
trigger2 = Time = 4
x = 0

[State 0, go to sikuruu super state]
type = ChangeState
trigger1 = var(0) = 20
trigger1 = var(1) > 0
value = 8340 + var(1)



; Stand to Crouch
;----------------

[Statedef 10]
Type = C
MoveType = I
Physics = C

[State 10, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 0, 4)

[State 10, animation]
type = ChangeAnim
trigger1 = time = 0
value = ifelse(var(0)=0, 10, 8010)

[State 10, vel mul]
type = VelMul
trigger1 = time = 0
x = .75

[State 10, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 11



; Crouching
;----------

[Statedef 11]
Type = C
MoveType = I
Physics = C
velset = 0,0

[State 11, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 0, 4)

[State 11, normal stance]
type = ChangeAnim
triggerall = var(0) = 0
trigger1 = Anim != 11 && Anim != 6
trigger2 = Anim = 6 && AnimTime = 0
value = 11

[State 0, Sikuruu turn]
type = ChangeAnim
triggerall = var(0) = 20
trigger1 = Anim != 8006 && Anim = 6
value = 8006

[State 0, Sikuruu stance]
type = ChangeAnim
triggerall = var(0) = 20
trigger1 = Anim != 8011 && Anim != 8006 && Anim != 6
trigger2 = Anim = 8006 && AnimTime = 0
value = 8011



; Crouch to Stand
;----------------

[Statedef 12]
Type = S
MoveType = I
Physics = S
velset = 0,0

[State 12, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 0, 4)

[State 12, animation]
type = ChangeAnim
trigger1 = time = 0
value = ifelse(var(0)=0, 12, 8012)

[State 12, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0



; Walk
;-----

[Statedef 20]
Type = S
MoveType = I
Physics = N

[State 0, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 1, 4)

[State 20, velocity forward]
type = VelSet
trigger1 = command = "holdfwd"
x = const(velocity.walk.fwd.x)

[State 20, velocity back]
type = VelSet
trigger1 = command = "holdback"
x = const(velocity.walk.back.x)

[State 20, walf fwd animation]
type = ChangeAnim
triggerall = vel x > 0
trigger1 = anim != 20
trigger1 = anim != 8020
value = ifelse(var(0)=0, 20, 8020)

[State 20, walk back animation]
type = ChangeAnim
triggerall = vel x < 0
trigger1 = anim != 21
trigger1 = anim != 8021
value = ifelse(var(0)=0, 21, 8021)



; Jump Start
;-----------

[Statedef 40]
Type = S
MoveType = I
Physics = S
anim = 40
ctrl = 0

[State 0, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 0, 4)

[State 40, long jump var init]
type = VarSet
trigger1 = time = 0
v = 4
value = ((PrevStateNo = [100, 102]) || command = "DU")

[State 40, var init]
type = VarSet
trigger1 = Time = 0
sysvar(1) = 0

[State 40, var fwd]
type = VarSet
trigger1 = command = "holdfwd"
sysvar(1) = 1

[State 40, var back]
type = VarSet
trigger1 = command = "holdback"
sysvar(1) = -1

[State 40, fwd velocity]
type = VelSet
trigger1 = AnimTime = 0 && var(4) = 0 && sysvar(1) = 1
x = const(velocity.jump.fwd.x) + 1.125*(var(0)=20)

[State 40, fast fwd velocity]
type = VelSet
trigger1 = AnimTime = 0 && var(4) = 1 && sysvar(1) = 1
x = const(velocity.runjump.fwd.x) + 1.*(var(0)=20)

[State 40, back velocity]
type = VelSet
trigger1 = AnimTime = 0 && var(4) = 0 && sysvar(1) = -1
x = const(velocity.jump.back.x) - 0.875*(var(0)=20)

[State 40, fast back velocity]
type = VelSet
trigger1 = AnimTime = 0 && var(4) = 1 && sysvar(1) = -1
x = const(velocity.runjump.back.x) - 1.25*(var(0)=20)

[State 40, neutral vertical velocity]
type = VelSet
trigger1 = AnimTime = 0 && sysvar(1) = 0
y = const(velocity.jump.y) + 2.18*(var(0)=20)*(const(movement.yaccel)=0.66)

[State 40, moving vertical velocity]
type = VelSet
trigger1 = AnimTime = 0 && sysvar(1) != 0
y = const(velocity.jump.y) + 3.59*(var(0)=20)*(const(movement.yaccel)=0.66)

[State 40, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 50
ctrl = 1



; Triangle Jump Start
;--------------------

[Statedef 45]
Type = A
MoveType = I
Physics = A
anim = 48
SprPriority = 1
ctrl = 0

[State 45, turn] ; turn the player if he is facing the wall
type = Turn
trigger1 = FrontEdgeBodyDist = 0

[State 45, jump velocities]
type = VelSet
trigger1 = AnimElem = 2
x = const(velocity.airjump.fwd.x)
y = const(velocity.airjump.y)

[State 45, jump, sound]
type = PlaySnd
trigger1 = AnimElem = 2
value = 100, 1
channel = 1

[State 45, control]
type = CtrlSet
trigger1 = AnimElem = 2
value = 1



; Jump Up
;--------

[Statedef 50]
Type = A
MoveType = I
Physics = A

[State 50, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 1, 4)

[State 50, var]
type = VarSet
trigger1 = time = 0
sysvar(1) = 0

[State 50, small jump] ; decreases velocity if the player has released the "up" direction (small jump)
type = VelAdd
trigger1 = time = 5
trigger1 = command != "holdup"
trigger1 = prevstateno = 40
y = 3.5

[State 50, additional gravity]
type = VelAdd
trigger1 = var(0) = 20 && const(movement.yaccel) = 0.66
y = -0.07 - 0.02*(vel x != 0)

[State 50, normal animation]
type = ChangeAnim
trigger1 = var(0) = 0
trigger1 = time = 0
value = ifelse((vel x)=0, 41, ifelse((vel x)>0, 42, 43))

[State 50, sikuruu animation]
type = ChangeAnim
trigger1 = var(0) = 20
trigger1 = time = 0
value = ifelse((vel x)=0, 8041, ifelse((vel x)>0, 8042, 8043))

[State 50, jump sound]
type = PlaySnd
trigger1 = Time = 1
value = 100, 1
channel = 1

[State 50, after images]
type = AfterImage
trigger1 = time = 0 && var(4) = 1
time = 45
length = 5
palbright = 0,0,0
palcontrast = 128,128,128
paladd = 0,0,0
palmul = 1,1,1
trans = add1
timegap = 1
framegap = 2



; Jump Down
;----------

[Statedef 51]
Type = A
MoveType = I
Physics = A

[State 51, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 1, 4)



; Jump Land
;----------

[Statedef 52]
Type = S
MoveType = I
Physics = S
ctrl = 0
;facep2 = 1

[State 52, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 0, 4)

[State 52, animation]
type = ChangeAnim
trigger1 = time = 0
value = ifelse(var(0)=0, 47, 8047)

[State 52, velocity]
type = VelSet
trigger1 = Time = 0
x = 0
y = 0

[State 52, position]
type = PosSet
trigger1 = Time = 0
y = 0

[State 52, control]
type = CtrlSet
trigger1 = Time = 3
value = 1

[State 52, turn]
type = Turn
triggerall = P2Dist x < 0
trigger1 = command = "holdfwd"
trigger2 = command = "holdback"
trigger3 = command = "holdup"

[State 52, land sound]
type = PlaySnd
trigger1 = Time = 1
value = 100, 2
channel = 1

[State 52, remove after images]
type = AfterImageTime
trigger1 = time = 0
time = 0

[State 52, end state]
type = ChangeState
trigger1 = var(0) = 0 && Time = 17
trigger2 = var(0) = 20 && Time = 6
value = 0
ctrl = 1



; Dodge Neutral
;--------------

[Statedef 60]
Type = S
MoveType = I
Physics = S
anim = 60
sprpriority = -2
ctrl = 0

[State 60, ghost]
type = PlayerPush
trigger1 = 1
value = 0

[State 60, invincible]
type = nothitby
trigger1 = 1
value = SCA

[State 60, voice]
type = PlaySnd
trigger1 = AnimElem = 1
value = 0, 1
channel = 0

[State 60, end state]
type = ChangeState
trigger1 = Animtime = 0
value = 0
ctrl = 1



; Lay Down
;---------

[Statedef 61]
Type = C
MoveType = A
Physics = C
anim = 61
sprpriority = 1
ctrl = 0

[State 61, invincible to high/air attacks]
type = nothitby
trigger1 = 1
value = SA

[State 61, end state]
type = ChangeState
trigger1 = Animtime = 0
value = 0
ctrl = 1



; Hop Forward
;------------

; Air
;----
[Statedef 62]
Type = A
MoveType = A
Physics = N
anim = 62
sprpriority = 1
velset = 5, -5
ctrl = 0

[State 62, ghost]
type = playerpush
trigger1 = 1
value = 0

[State 62, gravity]
type = veladd
trigger1 = 1
y = 0.45

[State 62, jump sound]
type = PlaySnd
trigger1 = Time = 1
value = 100, 1
channel = 1

[State 62, end state]
type = ChangeState
trigger1 = Animtime = 0
value = 64



; Lower Evade
;------------

[Statedef 63]
Type = A
MoveType = A
Physics = N
anim = 63
sprpriority = 1
velset = 0, -6
ctrl = 0

[State 63, ghost]
type = playerpush
trigger1 = 1
value = 0

[State 63, gravity]
type = veladd
trigger1 = 1
y = 0.6

[State 63, jump sound]
type = PlaySnd
trigger1 = Time = 1
value = 100, 1
channel = 1

[State 63, end state]
type = ChangeState
trigger1 = Animtime = 0
value = 64



; Land
;-----
[Statedef 64]
Type = S
MoveType = I
Physics = S
anim = 64
sprpriority = 1
velset = 0, 0
ctrl = 0

[State 64, ground position]
type = posset
trigger1 = 1
y = 0

[State 64, land sound]
type = PlaySnd
trigger1 = Time = 1
value = 100, 2
channel = 1

[State 64, end state]
type = ChangeState
trigger1 = time = 7
value = 0
ctrl = 1



; SS4 Dodge Forward
;------------------

[Statedef 65]
Type = S
MoveType = I
Physics = N
anim = 65
sprpriority = 3
ctrl = 0

[State 65, velset]
type = velset
trigger1 = 1
x = 5

[State 65, ghost]
type = PlayerPush
trigger1 = 1
value = 0

[State 65, invincible]
type = nothitby
trigger1 = 1
value = SCA

[State 65, turn]
type = turn
trigger1 = AnimTime = 0

[State 65, dodge sound]
type = PlaySnd
trigger1 = time = 1
value = 100, 4
channel = 1

[State 65, end state]
type = ChangeState
trigger1 = Animtime = 0
value = 0
ctrl = 1



; Dodge Roll Forward - Adapted from NeoGouki's Chris
;-------------------

[Statedef 66]
type = S
movetype = I
physics = N
anim = 66
sprpriority = -2
velset = 0
ctrl = 0

[State 66, hit by]
type = HitBy
trigger1 = Time = 0
value = SCA, NT, ST, HT
time = 20

[State 66, pause]
type = Pause
trigger1 = Time = 0 && (prevstateno = 150 || prevstateno = 152)
time = 10
movetime = 10

[State 66, envcolor]
type = EnvColor
trigger1 = Time = 0 && (prevstateno = 150 || prevstateno = 152)
time = 4
value = 255,255,255
under = 1

[State 66, power]
type = PowerAdd
trigger1 = Time = 0 && (prevstateno = 150 || prevstateno = 152)
value = -1000

[State 66, sprite priority]
type = SprPriority
trigger1 = AnimElem = 4
value = -3

[State 66, velocity]
type = VelSet
trigger1 = AnimElem = 4
x = 6 + 2*(prevstateno = 150 || prevstateno = 152)

[State 66, velocity]
type = VelSet
trigger1 = AnimElem = 13
x = 0

[State 66, ghost]
type = PlayerPush
trigger1 = AnimElem = 4, >= 0
trigger1 = AnimElem = 13, < 0
value = 0

[State 66, after images]
type = AfterImage
trigger1 = time = 0
time = 30
length = 5
palbright = 0,0,0
palcontrast = 128,128,128
paladd = 0,0,0
palmul = 1,1,1
trans = add1
timegap = 1
framegap = 2

[State 66, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1



; Dodge Roll Back - Adapted from NeoGouki's Chris
;----------------

[Statedef 67]
type = S
movetype = I
physics = N
anim = 67
sprpriority = -2
velset = 0
ctrl = 0

[State 67, hit by]
type = HitBy
trigger1 = Time = 0
value = SCA, NT, ST, HT
time = 20

[State 67, pause]
type = Pause
trigger1 = Time = 0 && (prevstateno = 150 || prevstateno = 152)
time = 10
movetime = 10

[State 67, envcolor]
type = EnvColor
trigger1 = Time = 0 && (prevstateno = 150 || prevstateno = 152)
time = 4
value = 255,255,255
under = 1

[State 67, power]
type = PowerAdd
trigger1 = Time = 0 && (prevstateno = 150 || prevstateno = 152)
value = -1000

[State 67, sprite priority]
type = SprPriority
trigger1 = AnimElem = 4
value = -3

[State 67, velocity]
type = VelSet
trigger1 = AnimElem = 4
x = -6 - 2*(prevstateno = 150 || prevstateno = 152)

[State 67, stop velocity]
type = VelSet
trigger1 = AnimElem = 13
x = 0

[State 67, ghost]
type = PlayerPush
trigger1 = AnimElem = 4, >= 0
trigger1 = AnimElem = 13, < 0
value = 0

[State 67, after images]
type = AfterImage
trigger1 = time = 0
time = 45
length = 5
palbright = 0,0,0
palcontrast = 128,128,128
paladd = 0,0,0
palmul = 1,1,1
trans = add1
timegap = 1
framegap = 2

[State 67, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1



; SS V Roll Forward
;------------------

[Statedef 68]
type = S
movetype = A
physics = N
anim = 68
sprpriority = 1
velset = 0
ctrl = 0

[State 68, velocity]
type = VelSet
trigger1 = time = 1
x = 8

[State 68, velocity]
type = VelSet
trigger1 = time = 6
x = 7

[State 68, velocity]
type = VelSet
trigger1 = time = 11
x = 6

[State 68, velocity]
type = VelSet
trigger1 = time = 14
x = 5

[State 68, velocity]
type = VelSet
trigger1 = time = 17
x = 4.5

[State 68, velocity]
type = VelSet
trigger1 = time = 21
x = 0

[State 68, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1



; SS V Roll Back
;---------------

[Statedef 69]
type = S
movetype = A
physics = N
anim = 69
sprpriority = -2
velset = 0
ctrl = 0

[State 69, velocity]
type = VelSet
trigger1 = time = 1
x = -7

[State 69, velocity]
type = VelSet
trigger1 = time = 3
x = -6.5

[State 69, velocity]
type = VelSet
trigger1 = time = 6
x = -6

[State 69, velocity]
type = VelSet
trigger1 = time = 9
x = -4.5

[State 69, velocity]
type = VelSet
trigger1 = time = 12
x = -4

[State 69, velocity]
type = VelSet
trigger1 = time = 15
x = -3

[State 69, velocity]
type = VelSet
trigger1 = time = 17
x = 0

[State 69, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1



; Life Recovery
;--------------

[Statedef 70]
Type = L
MoveType = I
Physics = N
sprpriority = 1
velset = 0,0

[State 70, life add]
type = LifeAdd
trigger1 = Time = 0
value = ceil((const(data.life) - life)/10)	; the less remains, the more is given

[State 70, timer set]
type = VarSet
trigger1 = Time = 0
fv = 5
value = 0

[State 70, timer]
type = VarSet
trigger1 = Time > 0
fv = 5
value = fvar(5) + 12.8

[State 70, pal effect]
type = PalFx
trigger1 = Time = [0,10]
time = 1
add = ceil(255-fvar(5)), ceil(255-fvar(5)), ceil(255-fvar(5))

[State 70, end state]
type = ChangeState
trigger1 = Time = 60
value = 5120



; Roll Forward Get Up
;--------------------

[Statedef 76]
Type = C
MoveType = I
Physics = N
sprpriority = -2
ctrl = 0

[State 76, animation]
type = ChangeAnim
trigger1 = time = 0
value = ifelse(anim = 5110, 76, 77)

[State 76, velset]
type = VelSet
trigger1 = AnimElem = 3
x = 4.8

[State 76, velset]
type = VelSet
trigger1 = AnimTime = 3
x = 0

[State 76, ghost]
type = PlayerPush
trigger1 = 1
value = 0

[State 76, invincibility]
type = NotHitBy
trigger1 = 1
value = SCA

[State 76, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1



; Roll Back Get Up
;-----------------

[Statedef 78]
Type = C
MoveType = I
Physics = N
sprpriority = -2
ctrl = 0

[State 78, animation]
type = ChangeAnim
trigger1 = time = 0
value = ifelse(anim = 5110, 78, 79)

[State 78, velset]
type = VelSet
trigger1 = AnimElem = 3
x = -4.8

[State 78, velset]
type = VelSet
trigger1 = AnimTime = 5
x = 0

[State 78, ghost]
type = PlayerPush
trigger1 = 1
value = 0

[State 78, invincibility]
type = NotHitBy
trigger1 = 1
value = SCA

[State 78, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1



; Jump on falcon
;---------------
: Jump
;-----
[Statedef 80]
Type = A
MoveType = I
Physics = N
anim = 80
sprpriority = 1
ctrl = 0

[State 80, velocity]
type = VelSet
trigger1 = time = 0
x = -(helper(7000), ParentDist x - 1)/3
y = -8.5

[state 80, voice]
type = PlaySnd
trigger1 = time = 1
value = 40,3
channel = 0

[state 80, jump sound]
type = PlaySnd
trigger1 = Time = 1
value = 100, 1
channel = 1

[State 80, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 81

: Land on falcon
;---------------
[Statedef 81]
Type = A
MoveType = I
Physics = A
anim = 81
sprpriority = 1

[State 81, Nako state var]
type = VarSet
trigger1 = time = 0
v = 0
value = 10

[State 81, mamahaha var]
type = VarSet
trigger1 = time = 0
v = 10
value = 0

[State 81, velocity]
type = VelSet
trigger1 = 1
x = 0
y = 0

[State 81, go down 1]
type = PosAdd
trigger1 = Time = 1
y = 2

[State 81, go down 2]
type = PosAdd
trigger1 = Time = 2
y = 5

[State 81, go down 3]
type = PosAdd
trigger1 = Time = 3
trigger2 = Time = 4
y = 3

[State 81, go down 4]
type = PosAdd
trigger1 = Time = 5
trigger2 = Time = 6
y = 1

[State 81, go up 1]
type = PosAdd
trigger1 = Time = 7
trigger2 = Time = 8
y = -1

[State 81, go up 2]
type = PosAdd
trigger1 = Time = 9
trigger2 = Time = 10
y = -3

[State 81, go up 3]
type = PosAdd
trigger1 = Time = 11
y = -5

[State 81, set var 0]
type = VarSet
trigger1 = Time = 0
v = 0
value = 10

[State 81, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 7000
ctrl = 1



; Leave falcon
;-------------
: Air
;----
[Statedef 85]
Type = A
MoveType = I
Physics = A
anim = 85
sprpriority = 1
ctrl = 0

[State 85, Nako state var]
type = VarSet
trigger1 = time = 0
v = 0
value = 0

[State 85, horyzontal velocity]
type = VelSet
trigger1 = time = 0
trigger1 = command != "a" && command != "b" && command != "c"
x = 0

[State 85, end state]
type = ChangeState
trigger1 = vel y >= 0
trigger1 = pos y >= -ceil(vel y)
value = 86

: Land
;-----
[Statedef 86]
Type = S
MoveType = I
Physics = S
anim = 86
sprpriority = 1
ctrl = 0

[State 86, velocity]
type = VelSet
trigger1 = time = 0
x = 0
y = 0

[State 86, position]
type = PosSet
trigger1 = Time = 0
y = 0

[State 86, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1



; Jump on wolf
;-------------
: Jump
;-----
[Statedef 90]
Type = A
MoveType = I
Physics = A
anim = 90
sprpriority = 1
ctrl = 0

[state 90, long fwd velocity]
type = VelSet
triggerall = time = 0
trigger1 = helper(8000), ParentDist x > 100
trigger1 = helper(8000), facing = facing
trigger2 = helper(8000), ParentDist x < -100
trigger2 = helper(8000), facing != facing
x = -100/18
y = -12

[state 90, long back velocity]
type = VelSet
triggerall = time = 0
trigger1 = helper(8000), ParentDist x < -100
trigger1 = helper(8000), facing = facing
trigger2 = helper(8000), ParentDist x > 100
trigger2 = helper(8000), facing != facing
x = 100/18
y = -12

[state 90, short velocity 1]
type = VelSet
triggerall = helper(8000), facing = facing
triggerall = time = 0
trigger1 = helper(8000), ParentDist x = [-100, 100]
x = -(helper(8000), ParentDist x)/18
y = -12

[state 90, short velocity 2]
type = VelSet
triggerall = helper(8000), facing != facing
triggerall = time = 0
trigger1 = helper(8000), ParentDist x = [-100, 100]
x = (helper(8000), ParentDist x)/18
y = -12

[state 90, gravity]
type = VelAdd
trigger1 = 1
y = 0.6 + 0.14*(const(movement.yaccel) = 0.52)

[state 90, voice]
type = PlaySnd
trigger1 = time = 1
value = 40,5
channel = 0

[state 90, jump sound]
type = PlaySnd
trigger1 = Time = 1
value = 100, 1
channel = 1

[State 90, end state]
type = ChangeState
trigger1 = time = 18
trigger1 = helper(8000), ParentDist x = [-50, 50]
trigger1 = helper(8000), StateNo = [8500, 8506]
value = 91

: Land
;-----
[Statedef 91]
Type = S
MoveType = I
Physics = S
anim = 91
sprpriority = 4

[State 91, velocity]
type = VelSet
trigger1 = Time = 0
x = 0
y = 0

[State 91, position]
type = PosSet
trigger1 = Time = 0
y = 0

[State 91, set var 0]
type = VarSet
trigger1 = Time = 0
v = 0
value = 20

[State 91, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1



; Get off wolf
;-------------

[Statedef 95]
Type = A
MoveType = I
Physics = A
sprpriority = 1
velset = 0,0
ctrl = 1

[State 95, set var 0]
type = VarSet
trigger1 = Time = 1
v = 0
value = 0

[State 95, set var 1]
type = VarSet
trigger1 = time = 0
v = 5
value = 0

[State 95, hold forward]
type = VarSet
trigger1 = command = "holdfwd"
v = 5
value = 1

[State 95, holdback]
type = VarSet
trigger1 = command = "holdback"
v = 5
value = -1

[State 95, change anim]
type = ChangeAnim
trigger1 = Time = 0
value = ifelse(var(5)=0, 41, ifelse(var(5)>0, 42, 43))

[State 95, velocities]
type = VelSet
trigger1 = Time = 0
x = ifelse(var(5)=0, const(velocity.jump.neu.x), ifelse(var(5)=1, const(velocity.jump.fwd.x), const(velocity.jump.back.x)))
y = const(velocity.jump.y)

[State 95, run velocity]
type = VelSet
trigger1 = Time = 0
trigger1 = prevstateno = 100
trigger1 = var(5) = 1
x = const(velocity.runjump.fwd.x)
y = const(velocity.runjump.y)

[state 95, jump sound]
type = PlaySnd
trigger1 = Time = 1
value = 100, 1
channel = 1



; Run
;----

[Statedef 100]
Type = S
MoveType = I
Physics = N
ctrl = 0

[State 100, animation]
type = ChangeAnim
trigger1 = time = 0
value = ifelse(var(0)=0, 100, 8100)

[State 100, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 1, 4)

[State 100, velocity]
type = VelSet
trigger1 = 1
x = const(velocity.run.fwd.x) + (var(0)=20)

[State 100, 2] ;Prevent run from canceling into walk
type = AssertSpecial
trigger1 = 1
flag = NoWalk

[State 100, 3] ;Prevent from turning
type = AssertSpecial
trigger1 = 1
flag = NoAutoTurn

[State 100, player push]
type = PlayerPush
trigger1 = var(0) = 20
value = 0

[State 100, voice]
type = PlaySnd
triggerall = var(0) = 20
trigger1 = time = 0
value = 0, 1
channel = 0

[State 100, run sound]
type = PlaySnd
triggerall = var(0) = 0
trigger1 = time = 0
trigger2 = (GameTime%47) = 0
value = 100, 3
channel = 1

[State 100, end state] ; brake when stop running
type = ChangeState
triggerall = command != "holdfwd"
trigger1 = var(0) = 0
trigger2 = var(0) = 20 && helper(8000), AnimElem = 5
value = 101



; Brake
;------

[Statedef 101]
Type = S
MoveType = I
Physics = S
ctrl = 0

[State 101, animation]
type = ChangeAnim
trigger1 = time = 0
value = ifelse(var(0)=0, 101, 8101)

[State 101, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 1, 4)

[State 101, velocity]
type = VelSet
trigger1 = time = 0
x = 3.5 + 5.82*(var(0)=20)
y = 0

[State 101, friction]
type = VelMul
trigger1 = 1
x = 1.12 - 0.1*(var(0)=20)

[State 101, position]
type = PosSet
trigger1 = time = 0
y = 0

[State 101, remove explod]
type = RemoveExplod
trigger1 = time = 0
ID = 8300

[State 101, dust 01]
type = MakeDust
trigger1 = var(0) = 0
trigger1 = vel x > 0
pos = 0, 0
spacing = 3

[State 101, dust 02]
type = MakeDust
trigger1 = var(0) = 0
trigger1 = vel x > 0
pos = 55, 0
spacing = 3

[State 101, brake sound]
type = PlaySnd
trigger1 = var(0) = 0
trigger1 = Time = 1
value = 100, 4
channel = 1

[State 101, end state]
type = ChangeState
trigger1 = time = 15 - 3*(var(0)=20)
value = 0
ctrl = 1



; Hop back
;---------

[Statedef 105]
Type = A
MoveType = I
Physics = A
ctrl = 0

[State 105, animation]
type = ChangeAnim
trigger1 = time = 0
value = ifelse(var(0)=0, 105, 8105)

[State 105, sprite priority]
type = SprPriority
trigger1 = time = 0
value = ifelse(var(0)!=20, 1, 4)

[State 105, velocity]
type = VelSet
trigger1 = time = 0
x = const(velocity.run.back.x) + 3.2*(var(0)=20)
y = const(velocity.run.back.y) - 1.8*(var(0)=20)

[State 105, vel add]
type = VelAdd
trigger1 = Time > 0
y = -0.23 + 0.13*(const(movement.yaccel) = 0.52) + 0.1*(var(0)=20)

[State 105, jump sound]
type = PlaySnd
trigger1 = Time = 1
value = 100, 1
channel = 1

[State 105, change state]
type = ChangeState
trigger1 = time = 16 + 4*(var(0)=20)
value = 52



; Suicide ; Adapted from C Kenny's and System ID's Sogetsu
;--------

[Statedef 110]
type = S
anim = 110
velset = 0,0
ctrl = 0

[State 110, invincibility]
type = NotHitBy
trigger1 = 1
value = SCA

[State 110, assert special]
type = AssertSpecial
trigger1 = 1
flag = NoKOSnd
flag2 = NoBg
flag3 = NoFg

[State 110, life]
type = LifeSet
trigger1 = AnimElem = 15
value = 0

[State 110, power] ; power gauge full in new modes
type = PowerSet
trigger1 = const(movement.yaccel) != 0.66
trigger1 = AnimElem = 15
value = 3000

[State 110, power] ; hit gauge full
type = VarSet
trigger1 = var(20) = 0 && AnimElem = 15
v = 23
value = 1000

[State 110, power] ; rage gauge full
type = VarSet
trigger1 = var(20) = 1 && AnimElem = 15
v = 21
value = 1000

[State 110, sparks 1]
type = Explod
trigger1 = AnimElem = 4, = 6
id = 110
anim = 111
pos = -8, -52
sprpriority = 3
removetime = 30
ownpal = 1

[State 110, sparks 2]
type = Explod
trigger1 = AnimElem = 12
id = 110
anim = 111
pos = -16, -65
sprpriority = 3
removetime = 32
ownpal = 1
vel = 0.5, -2.6875

[State 110, sparks 3]
type = Explod
trigger1 = AnimElem = 4, = 8
id = 110
anim = 4140
pos = 11, 21
sprpriority = 3
removetime = -2
ownpal = 1
facing = -1
vel = 0, -4

[State 110, sparks 4]
type = Explod
trigger1 = AnimElem = 10
id = 110
anim = 4140
pos = -28, -80
sprpriority = 3
removetime = -2
ownpal = 1
vel = 0, -4

[state 110, sparks sound]
type = PlaySnd
trigger1 = AnimElem = 4, = 6
value = 160, 1
channel = 2

[State 110, end state]
type = ChangeState
trigger1 = AnimElem = 15
value = 5150



; Guard
;------
; Start
;------
[Statedef 120]
Type = U
MoveType = I
Physics = U
sprpriority = -1

[State 120, ground animation]
type = ChangeAnim
trigger1 = time = 0 && statetype != A
value = 120 + (statetype = C) + 8000*(var(0)=20)

[State 120, air animation]
type = null;ChangeAnim
trigger1 = time = 0 && statetype = A
value = 122 + 7000*(var(0)=10) + 8000*(var(0)=20)

[State 120, stand type set]
type = StateTypeSet
trigger1 = time = 0 && statetype = S
physics = S

[State 120, crouch type set]
type = StateTypeSet
trigger1 = time = 0 && statetype = C
physics = C

[State 120, air type set]
type = StateTypeSet
trigger1 = var(0) != 10
trigger1 = time = 0 && statetype = A
physics = A

[State 120, air control]
type = CtrlSet
trigger1 = time = 0 && statetype = A
value = 1

[State 120, Hi to Lo]
type = StateTypeSet
trigger1 = statetype = S && command = "holddown"
statetype = C
physics = C

[State 120, Lo to Hi]
type = StateTypeSet
trigger1 = statetype = C && command != "holddown"
statetype = S
physics = S

[State 120, change state]
type = ChangeState
trigger1 = StateType != A && AnimTime = 0
trigger2 = StateType = A && Time = 0
value = 130 + 1*(statetype = C) + 2*(statetype = A)

[State 120, Stop Guarding]
type = ChangeState
trigger1 = command != "holdback"
;trigger2 = !inguarddist
value = 140



; Stand Guarding
;---------------
[Statedef 130]
Type = S
MoveType = I
Physics = S
sprpriority = -1
velset = 0,0

[State 130, animation] ; stand alone
type = ChangeAnim
trigger1 = var(0) = 0 && anim != 130
value = 130

[State 130, animation] ; carried by Shikuruu
type = ChangeAnim
trigger1 = var(0) = 20 && anim != 8130
value = 8130

[State 130, Hi to Lo]
type = ChangeState
trigger1 = command = "holddown"
value = 131

[State 130, Stop Guarding]
type = ChangeState
trigger1 = command != "holdback"
;trigger2 = !inguarddist
value = 140

; Crouch Guarding
;----------------
[Statedef 131]
Type = C
MoveType = I
physics = C
sprpriority = -1
velset = 0,0

[State 131, 1]
type = ChangeAnim
trigger1 = var(0) != 10
trigger1 = anim != 131 && anim != 8131
value = 131 + 8000*(var(0)=20)

[State 131, Lo to Hi]
type = ChangeState
trigger1 = command != "holddown"
value = 130

[State 131, Stop Guarding]
type = ChangeState
trigger1 = command != "holdback"
;trigger2 = !inguarddist
value = 140

; Air Guarding
;-------------
[Statedef 132]
Type = A
MoveType = I
Physics = N
sprpriority = -1
ctrl = 1

[State 132, animation]
type = null;ChangeAnim
trigger1 = anim != 132 && anim != 7132 && anim != 8132
value = 132 + 7000*(var(0)=10) + 8000*(var(0)=20)

[State 132, velocity]
type = VelAdd
trigger1 = var(0) != 10
y = Const(movement.yaccel)

[State 132, sysvar]
type = VarSet
trigger1 = 1
sysvar(0) = (pos y >= -10) && (vel y > 0)

[State 132, land]
type = VelSet
trigger1 = sysvar(0)
y = 0

[State 132, land]
type = PosSet
trigger1 = sysvar(0)
y = 0

[State 132, land state]
type = ChangeState
trigger1 = sysvar(0)
trigger1 = command != "holdback"
value = 52

[State 132, guard state]
type = ChangeState
trigger1 = sysvar(0)
trigger1 = command = "holdback"
;trigger1 = inguarddist
value = 130

[State 132, Stop Guarding]
type = ChangeState
trigger1 = command != "holdback"
;trigger2 = !inguarddist
value = 140



; End Guard
;----------
[Statedef 140]
Type = U
MoveType = I
Physics = U
sprpriority = -1
ctrl = 1

[State 140, ground normal animation]
type = ChangeAnim
trigger1 = var(0) = 0
trigger1 = time = 0 && statetype != A
value = 140 + (statetype = C)

[State 140, carried by a pet animation]
type = ChangeAnim
trigger1 = var(0) != 0
trigger1 = time = 0 && statetype != A
value = 120 + (statetype = C) + 8000*(var(0)=20)

[State 140, air animation]
type = null;ChangeAnim
trigger1 = time = 0 && statetype = A
value = 122 + 7000*(var(0)=10) + 8000*(var(0)=20)

[State 140, stand type set]
type = StateTypeSet
trigger1 = time = 0 && statetype = S
physics = S

[State 140, crouch type set]
type = StateTypeSet
trigger1 = time = 0 && statetype = C
physics = C

[State 140, air type set]
type = StateTypeSet
trigger1 = var(0) != 10
trigger1 = time = 0 && statetype = A
physics = A

[State 140, air control]
type = CtrlSet
trigger1 = time = 0 && statetype = A
value = 1

[State 140, Hi to Lo]
type = StateTypeSet
trigger1 = statetype = S && command = "holddown"
statetype = C
physics = C

[State 140, Lo to Hi]
type = StateTypeSet
trigger1 = statetype = C && command != "holddown"
statetype = S
physics = S

[State 140, change state]
type = ChangeState
trigger1 = var(0) = 10 && time = 0
value = 7000



; Stand Guarding A Hit
;---------------------
; Shaking
;--------
[Statedef 150]
Type = S
MoveType= H
Physics = N
SprPriority = -1
velset = 0,0

[State 150, animation] ; stand alone
type = ChangeAnim
trigger1 = var(0) = 0 && time = 0
value = 150 + 3*((enemy, StateType = A) && (PrevStateNo != [150,153])) + 4*(PrevStateNo = [150,153])

[State 150, animation] ; carried by Shikuruu
type = ChangeAnim
trigger1 = var(0) = 20 && time = 0
value = 8130

[State 150, end state]
type = ChangeState
trigger1 = HitShakeOver
value = 151

[State 150, Hi to Lo]
type = StateTypeSet
trigger1 = statetype = S && command = "holddown"
statetype = C
physics = C

[State 150, Lo to Hi]
type = StateTypeSet
trigger1 = statetype = C && command != "holddown"
statetype = S
physics = S

[State 150, force feedback]
type = ForceFeedback
trigger1 = time = 0
waveform = square
time = 3

; Knocked Back
;-------------
[Statedef 151]
Type = S
MoveType= H
Physics = S
SprPriority = -1

[State 151, hit velocity]
type = HitVelSet
trigger1 = Time = 0
x = 1

[State 151, velocity]
type = VelSet
trigger1 = Time = GetHitVar(slidetime)
trigger2 = HitOver
x = 0

[State 151, control]
type = CtrlSet
trigger1 = Time = GetHitVar(ctrltime)
value = 1

[State 151, Hi to Lo]
type = StateTypeSet
trigger1 = statetype = S && command = "holddown"
statetype = C
physics = C

[State 151, Lo to Hi]
type = StateTypeSet
trigger1 = statetype = C && command != "holddown"
statetype = S
physics = S

[State 151, end state]
type = ChangeState
trigger1 = Time >= GetHitVar(hittime)
value = 130
ctrl = 1



; Crouch Guarding A Hit
;----------------------
; Shaking
;--------
[Statedef 152]
Type = C
MoveType= H
Physics = N
SprPriority = -1
velset = 0,0

[State 152, animation]
type = ChangeAnim
trigger1 = var(0) != 10
value = ifelse(var(0)=0, 151, 8131)

[State 152, change state]
type = ChangeState
trigger1 = HitShakeOver
value = 151 + 2*(command = "holddown")

[State 152, Hi to Lo]
type = StateTypeSet
trigger1 = statetype = S && command = "holddown"
statetype = C
physics = C

[State 152, Lo to Hi]
type = StateTypeSet
trigger1 = statetype = C && command != "holddown"
statetype = S
physics = S

[State 152, force feedback]
type = ForceFeedback
trigger1 = time = 0
waveform = square
time = 4

; Knocked Back
:-------------
[Statedef 153]
Type = C
MoveType= H
Physics = C
SprPriority = -1

[State 153, hit vel set]
type = HitVelSet
trigger1 = Time = 0
x = 1

[State 153, velset]
type = VelSet
trigger1 = Time = GetHitVar(slidetime)
trigger2 = HitOver
x = 0

[State 153, control]
type = CtrlSet
trigger1 = Time = GetHitVar(ctrltime)
value = 1

[State 153, Hi to Lo]
type = StateTypeSet
trigger1 = statetype = S && command = "holddown"
statetype = C
physics = C

[State 153, Lo to Hi]
type = StateTypeSet
trigger1 = statetype = C && command != "holddown"
statetype = S
physics = S

[State 153, end state]
type = ChangeState
trigger1 = HitOver
value = 131
ctrl = 1



; Air Guarding A Hit
;-------------------
; Shaking
;--------
[Statedef 154]
Type = A
MoveType= H
Physics = N
SprPriority = -1
velset = 0,0

[State 154, animation]
type = ChangeAnim
trigger1 = 1
value = ifelse(var(0)=0, 152, ifelse( var(0)=10, 7132, 8132))

[State 154, change state]
type = ChangeState
trigger1 = HitShakeOver
value = 155

[State 154, force feedback]
type = ForceFeedback
trigger1 = time = 0
waveform = square
time = 4

; Knocked Away
;-------------
[Statedef 155]
Type = A
MoveType= H
Physics = N
SprPriority = -1

[State 155, hit velocity]
type = HitVelSet
trigger1 = Time = 0
x = 1
y = 1 -1*(var(0)=10)

[State 155, control]
type = CtrlSet
trigger1 = Time = GetHitVar(ctrltime)
value = 1

[State 155, gravity]
type = VelAdd
trigger1 = var(0) != 10
y = Const(movement.yaccel)

[State 155, var set]
type = VarSet
trigger1 = 1
sysvar(0) = (pos y >= -10) && (vel y > 0)

[State 155, land]
type = VelSet
trigger1 = sysvar(0)
y = 0

[State 155, land]
type = PosSet
trigger1 = sysvar(0)
y = 0

[State 155, ground guarding state]
type = ChangeState
trigger1 = sysvar(0)
trigger1 = command = "holdback"
;trigger1 = inguarddist
value = 130

[State 155, land state]
type = ChangeState
trigger1 = sysvar(0)
trigger1 = command != "holdback"
value = 52

[State 155, air end state]
type = ChangeState
trigger1 = var(0) = 10 && (time = GetHitVar(ctrltime) || time >= 60)
value = 132



; Concentration
;--------------

[Statedef 160]
Type = S
MoveType = I
Physics = S
anim = 160
sprpriority = 1
velset = 0,0
ctrl = 0

[State 160, add power]
type = poweradd
trigger1 = 1
value = 4

[State 160, aura]
type = explod
trigger1 = Time = 1
ID = 160
anim = 161
sprpriority = 0
ownpal = 1
bindtime = -1
removetime = -1
removeongethit = 1

[State 160, concentrate sound]
type = PlaySnd
trigger1 = time = 1
trigger2 = (GameTime%90) = 0
value = 100, 5
channel = 1

[State 160, complete sound]
type = PlaySnd
trigger1 = power = 3000
value = 100, 6
channel = 1

[State 160, end state]
type = ChangeState
trigger1 = (command != "holda") || (command != "holdb") || (command != "holdc")
trigger2 = (var(30) = 1) && (P2Dist x <= 160 || enemy, numproj > 0 || roundstate != 2)		; AI
trigger3 = power = 3000
value = 0
ctrl = 1



;================================================================================================
;
; NAKORURU'S INTROS, ENDINGS AND TAUNT STATES
;
;================================================================================================

; Time Over Lose
;---------------

[Statedef 170]
type = S
ctrl = 0
anim = 170
velset = 0,0

[State 170, invincibility]
type = NotHitBy
trigger1 = 1
value = SCA
time = 1

[state 170, voice]
type = PlaySnd
trigger1 = AnimElem = 2
value = 10, 1
channel = 0



; Draw Game
;----------

[Statedef 175]
type = S
ctrl = 0
velset = 0,0

[State 175, choose animation]
type = ChangeAnim
trigger1 = Time = 0
value = ifelse(random < 500, 175, 176) ; 50% to play 1st animation and thus, 50% to play the 2nd

[State 175, invincibility]
type = NotHitBy
trigger1 = 1
value = SCA
time = 1

[state 175, voice]
type = PlaySnd
trigger1 = Anim = 175 && AnimElem = 4
value = 0, 5
channel = 0

[state 175, voice]
type = PlaySnd
trigger1 = Anim = 176 && AnimElem = 3
value = 30, 0
channel = 0



; End Poses
;----------
; Choose
;-------
[Statedef 180]
type = S
ctrl = 0
velset = 0,0

[State 180, assert special]
type = AssertSpecial
trigger1 = Time = [0, 120]
flag = roundnotover

[State 180, randomizer]
type = VarRandom
trigger1 = Time = 0
v  = 6
range = 1,6

[State 180, 1st ending]
type = ChangeState
triggerall = helper(7000), ParentDist x = [40, 70]
trigger1 = command = "holdx"
value = 181

[State 180, 2nd ending]
type = ChangeState
triggerall = helper(7000), ParentDist x = [40, 70]
trigger1 = command = "holda"
value = 182

[State 180, 3rd ending]
type = ChangeState
triggerall = helper(7000), ParentDist x = [40, 70]
trigger1 = command = "holdy"
value = 183

[State 180, 4th ending]
type = ChangeState
triggerall = helper(7000), ParentDist x = [40, 70]
trigger1 = command = "holdb"
value = 184

[State 180, 5th ending]
type = ChangeState
triggerall = helper(7000), ParentDist x = [40, 70]
trigger1 = command = "holdz"
value = 185

[State 180, 6th ending]
type = ChangeState
triggerall = helper(7000), ParentDist x = [40, 70]
trigger1 = command = "holdc"
value = 186

[State 180, randomize]
type = ChangeState
triggerall = helper(7000), ParentDist x = [40, 70]
trigger1 = command != "holdx"
trigger2 = command != "holdy"
trigger3 = command != "holdz"
trigger4 = command != "holda"
trigger5 = command != "holdb"
trigger6 = command != "holdc"
value = 180 + var(6)



; Praise Ending
;--------------
[Statedef 181]
type = S
anim = 181
velset = 0,0
ctrl = 0

[State 181, assert special]
type = AssertSpecial
trigger1 = Time = [0, 200]
flag = roundnotover

[state 181, voice]
type = PlaySnd
trigger1 = AnimElem = 8
value = 30, 0
channel = 0



; Cape Twirl Ending
;------------------
[Statedef 182]
type = S
anim = 182
velset = 0,0
ctrl = 0

[State 182, assert special]
type = AssertSpecial
trigger1 = Time = [0, 290]
flag = roundnotover

[state 182, voice]
type = PlaySnd
trigger1 = AnimElem = 13
value = 30, 3
channel = 0

[state 182, cape sound]
type = PlaySnd
trigger1 = AnimElem = 4
value = 160, 0
channel = 1



; Slash Ending 01
;----------------
[Statedef 183]
type = S
anim = 183
velset = 0,0
ctrl = 0

[State 183, assert special]
type = AssertSpecial
trigger1 = Time = [0, 250]
flag = roundnotover

[state 183, voice]
type = PlaySnd
trigger1 = AnimElem = 4
value = 30, 1
channel = 0



; Slash Ending 02
;----------------
[Statedef 184]
type = S
anim = 184
velset = 0,0
ctrl = 0

[State 184, assert special]
type = AssertSpecial
trigger1 = Time = [0, 330]
flag = roundnotover

[State 184, 2]
type = Explod
trigger1 = AnimElem = 9
anim = 187
ontop = 1

[state 184, voice]
type = PlaySnd
trigger1 = AnimElem = 20
value = 30, 3
channel = 0

[state 184, cape sound]
type = PlaySnd
trigger1 = AnimElem = 4
value = 160, 0
channel = 1

[state 184, cape spark]
type = PlaySnd
trigger1 = AnimElem = 9
value = 160, 1
channel = 2



; Burst Ending 01
;----------------
[Statedef 185]
type = S
anim = 185
velset = 0,0
ctrl = 0

[State 185, assert special]
type = AssertSpecial
trigger1 = Time = [0, 250]
flag = roundnotover

[state 185, voice]
type = PlaySnd
trigger1 = AnimElem = 9
value = 30, 2
channel = 0



; Burst Ending 02
;----------------
[Statedef 186]
type = S
anim = 186
velset = 0,0
ctrl = 0

[State 186, assert special]
type = AssertSpecial
trigger1 = Time = [0, 200]
flag = roundnotover

[state 186, voice]
type = PlaySnd
trigger1 = AnimElem = 13
value = 30, 4
channel = 0

[state 186, cape sound]
type = PlaySnd
trigger1 = AnimElem = 4
value = 160, 0
channel = 1



; Morrigan Intro
;---------------

[Statedef 189]
type = S
sprpriority = 0

[State 189, 1]
type = ChangeAnim
trigger1 = RoundState = 0
value = 189

[State 189, 2]
type = AssertSpecial
trigger1 = 1
flag = Intro

[state 189, voice]
type = PlaySnd
trigger1 = AnimElem = 2
value = 20, 0
channel = 0

[State 189, Mamahaha]
type = Helper
trigger1 = AnimTime = 0
name = "Mamahaha"
ID = 7000
pos =-20,-122
postype = back
stateno = 7500
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 5
size.ground.front = 15
size.shadowoffset = 0

[State 189, Shikuruu]
type = Helper
trigger1 = AnimTime = 0
name = "Shikuruu"
ID = 8000
pos =-50,0
postype = back
stateno = 8500
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 30
size.ground.front = 30
size.air.back = 20
size.air.front = 20
size.shadowoffset = 1

[State 189, 3]
type = ChangeState
trigger1 = AnimTime = 0
value = 0



; Blade Intro
;------------

[Statedef 190]
type = S
sprpriority = 0

[State 190, randomizer]
type = VarRandom
trigger1 = Time = 0
v  = 6
range = 0,4

[State 190, vs Morrigan intro]
type = ChangeState
trigger1 = enemy, name = "Morrigan"
value = 189

[State 190, vs Nakoruru intro]
type = ChangeState
trigger1 = enemy, name = "New Nakoruru"
trigger2 = enemy, name = "Nakoruru"
trigger3 = enemy, name = "Rera"
value = 199

[State 190, other intros]
type = ChangeState
trigger1 = var(6) > 0
value = 190 + var(6)

[State 190, 1]
type = ChangeAnim
trigger1 = RoundState = 0
value = 190

[State 190, 2]
type = AssertSpecial
trigger1 = 1
flag = Intro

[state 190, voice]
type = PlaySnd
trigger1 = AnimElem = 2
value = 20, 0
channel = 0

[State 190, weapon]
type = Explod
trigger1 = Animelem = 1, = 3
anim = 198
sprpriority = 1
ownpal = 1

[State 190, Mamahaha]
type = Helper
trigger1 = Animelem = 1, = 3
name = "Mamahaha"
ID = 7000
pos = 165, -224
postype = p1
facing = -1
stateno = 7920
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 5
size.ground.front = 15
size.shadowoffset = -1

[State 190, Shikuruu]
type = Helper
trigger1 = AnimTime = 0
name = "Shikuruu"
ID = 8000
pos =-50,0
postype = back
stateno = 8500
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 30
size.ground.front = 30
size.air.back = 20
size.air.front = 20
size.shadowoffset = 1

[State 190, 3]
type = ChangeState
trigger1 = AnimTime = 0
value = 0



; Praise Intro
;-------------

[Statedef 191]
type = S
sprpriority = 0

[State 191, 1]
type = ChangeAnim
trigger1 = RoundState = 0
value = 191

[State 191, 2]
type = AssertSpecial
trigger1 = 1
flag = Intro

[State 191, voice]
type = PlaySnd
trigger1 = AnimElem = 5
value = 20, 0
channel = 0

[State 191, Mamahaha]
type = Helper
trigger1 = time = 0
name = "Mamahaha"
ID = 7000
pos =-19,-68
postype = p1
stateno = 7930
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 5
size.ground.front = 15
size.shadowoffset = -1

[State 191, Shikuruu]
type = Helper
trigger1 = time = 0
name = "Shikuruu"
ID = 8000
pos = 30,0
postype = p1
stateno = 8900
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 30
size.ground.front = 30
size.air.back = 20
size.air.front = 20
size.shadowoffset = 1

[State 191, 3]
type = ChangeState
trigger1 = AnimTime = 0
value = 0



; Calling Intro
;--------------

[Statedef 192]
type = S
sprpriority = 0

[State 192, 1]
type = ChangeAnim
trigger1 = RoundState = 0
value = 192

[State 192, 2]
type = AssertSpecial
trigger1 = 1
flag = Intro

[State 192, randomizer]
type = VarRandom
trigger1 = Time = 1
v  = 6
range = 0,1

[state 192, voice]
type = PlaySnd
trigger1 = AnimElem = 3
value = 40, 4 + var(6)
channel = 0

[State 192, Mamahaha]
type = Helper
trigger1 = AnimTime = 0
name = "Mamahaha"
ID = 7000
pos =-20,-122
postype = back
stateno = 7500
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 5
size.ground.front = 15
size.shadowoffset = 0

[State 192, Shikuruu]
type = Helper
trigger1 = AnimTime = 0
name = "Shikuruu"
ID = 8000
pos =-50,0
postype = back
stateno = 8500
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 30
size.ground.front = 30
size.air.back = 20
size.air.front = 20
size.shadowoffset = 1

[State 192, 3]
type = ChangeState
trigger1 = AnimTime = 0
value = 0



; Mamahaha Intro
;---------------

[Statedef 193]
type = S
sprpriority = 0

[State 193, 1]
type = ChangeAnim
trigger1 = RoundState = 0
value = 193

[State 193, 2]
type = AssertSpecial
trigger1 = 1
flag = Intro

[state 193, voice]
type = PlaySnd
trigger1 = time = 1
value = 20, 1
channel = 0

[State 193, Mamahaha]
type = Helper
trigger1 = time = 0
name = "Mamahaha"
ID = 7000
pos =-18,-70
postype = p1
stateno = 7940
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 5
size.ground.front = 15
size.shadowoffset = -1

[State 193, Shikuruu]
type = Helper
trigger1 = AnimTime = 0
name = "Shikuruu"
ID = 8000
pos =-50,0
postype = back
stateno = 8500
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 30
size.ground.front = 30
size.air.back = 20
size.air.front = 20
size.shadowoffset = 1

[State 193, 3]
type = ChangeState
trigger1 = AnimTime = 0
value = 0



; Shikuruu Intro
;---------------

[Statedef 194]
type = S
sprpriority = 0

[State 194, 1]
type = ChangeAnim
trigger1 = RoundState = 0
value = 194

[State 194, cape]
type = Explod
trigger1 = Animelem = 20
anim = 196
sprpriority = 3
ownpal = 1

[State 194, cape spark]
type = Explod
trigger1 = Animelem = 15
anim = 197
sprpriority = 3
ownpal = 1

[State 194, 2]
type = AssertSpecial
trigger1 = 1
flag = Intro

[state 194, voice]
type = PlaySnd
trigger1 = AnimElem = 3
value = 20, 2
channel = 0

[state 194, voice]
type = PlaySnd
trigger1 = AnimElem = 7
value = 40, 5
channel = 0

[state 194, cape sound]
type = PlaySnd
trigger1 = AnimElem = 11
value = 160, 0
channel = 1

[state 194, cape spark sound]
type = PlaySnd
trigger1 = AnimElem = 15
value = 160, 1
channel = 2

[State 194, Mamahaha]
type = Helper
trigger1 = AnimTime = 0
name = "Mamahaha"
ID = 7000
pos =-20,-122
postype = back
stateno = 7500
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 5
size.ground.front = 15
size.shadowoffset = 0

[State 194, Shikuruu]
type = Helper
trigger1 = AnimTime = 0
name = "Shikuruu"
ID = 8000
pos =-50,0
postype = back
stateno = 8500
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 30
size.ground.front = 30
size.air.back = 20
size.air.front = 20
size.shadowoffset = 1

[State 194, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0



; Vs Nakoruru Intro
;------------------

[Statedef 199]
type = S
sprpriority = 0

[State 199, 1]
type = ChangeAnim
trigger1 = RoundState = 0
value = 199

[State 199, 2]
type = AssertSpecial
trigger1 = 1
flag = Intro

[state 199, voice]
type = PlaySnd
trigger1 = AnimElem = 2
value = 20, 0
channel = 0

[State 199, Mamahaha]
type = Helper
trigger1 = AnimTime = 0
name = "Mamahaha"
ID = 7000
pos =-20,-122
postype = back
stateno = 7500
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 5
size.ground.front = 15
size.shadowoffset = 0

[State 199, Shikuruu]
type = Helper
trigger1 = AnimTime = 0
name = "Shikuruu"
ID = 8000
pos =-50,0
postype = back
stateno = 8500
keyctrl = 0
ownpal = 1
size.xscale = const(size.xscale)
size.yscale = const(size.yscale)
size.ground.back = 30
size.ground.front = 30
size.air.back = 20
size.air.front = 20
size.shadowoffset = 1

[State 199, 3]
type = ChangeState
trigger1 = AnimTime = 0
value = 0



; Taunt
;------

[Statedef 195]
Type = S
MoveType = I
Physics = S
sprpriority = 0
velset = 0,0
ctrl = 0

[State 195, animation]
type = ChangeAnim
trigger1 = anim != 195
value = 195

[State 195, slash voice]
type = PlaySnd
trigger1 = AnimElem = 9, = 10
value = 25, 0
channel = 0

[State 195, set control]
type = CtrlSet
trigger1 = AnimElem = 9, = 24
value = 1

[State 195, end state]
type = ChangeState
trigger1 = Animtime = 0
value = 0
ctrl = 1



;================================================================================================
;
; NAKORURU'S ADDITIONAL HIT STATES
;
;================================================================================================

; Lie Dead
;---------

[Statedef 5150]
type = L
movetype= H
physics = N
sprpriority = -3

[State 5150, normal anim]
type = ChangeAnim
triggerall = PrevStateNo != 110
triggerall = Time = 0
triggerall = SelfAnimExist(5140)
trigger1 = (anim != [5111,5119]) && (anim != [5171,5179])
trigger2 = !SelfAnimExist(5140 + (anim % 10))
value = 5140

[State 5150, hit up type anim]
type = ChangeAnim
triggerall = PrevStateNo != 110
trigger1 = Time = 0
trigger1 = (anim = [5111,5119]) || (anim = [5171,5179])
trigger1 = SelfAnimExist(5140 + (anim % 10))
value = 5140 + (anim % 10)

[State 5150, Match over anim]
type = ChangeAnim
persistent = 0
triggerall = PrevStateNo != 110
trigger1 = MatchOver = 1
trigger1 = Anim = [5140,5149]
trigger1 = SelfAnimExist(anim+10)
value = anim+10

[State 5150, liedead anim does not exist]
type = ChangeAnim
triggerall = PrevStateNo != 110
trigger1 = Time = 0
trigger1 = Anim != [5140,5159]
trigger1 = Anim != [5110,5119]
value = 5110

[State 5150, friction]
type = VelMul
trigger1 = 1
x = 0.85

[State 5150, friction]
type = VelSet
trigger1 = Vel x < .05
persistent = 0
x = 0

[State 5150, invincibility]
type = NotHitBy
trigger1 = 1
value = SCA
time = 1

[State 110, erase stage]
type = AssertSpecial
trigger1 = PrevStateNo = 110
flag = NoBg
flag2 = NoFg



; Hit Fall Recover On Ground
;---------------------------

[Statedef 5201]
type = C
movetype = H
physics = C
anim = 5200

[State 5201, turn] ;Turn if not facing opponent
type = Turn
trigger1 = Time = 0
trigger1 = p2dist X < -5

[State 5201, velocity]
type = VelSet
trigger1 = 1
x = -7
y = 0

[State 5201, position]
type = PosSet
trigger1 = Time = 0
y = 0

[State 5201, invincibility]
type = NotHitBy
trigger1 = 1
value = SCA
time = 1

[State 5201, blink] ;Blink white
type = PalFX
trigger1 = time = 0
time = 3
add = 128,128,128

[State 5201, end state]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1



; Hit Fall Recover In Mid Air
;----------------------------

[Statedef 5210]
type = A
movetype = I
physics = N
anim = 5210
ctrl = 0

[State 5210, blink] ;Blink white
type = PalFX
trigger1 = time = 0
time = 3
add = 128,128,128

[State 5210, freeze position]
type = PosFreeze
trigger1 = Time = 0
value = 4

[State 5210, turn] ;Turn if not facing opponent
type = Turn
trigger1 = time = 0
trigger1 = p2dist X < -20

[State 5210, velocity]
type = VelAdd
trigger1 = time = 4
x = -2
y = -5

[State 5210, invincibility]
type = NotHitBy
trigger1 = time = 0
value = SCA
time = 15

[State 5210, control]
type = CtrlSet
trigger1 = time = 15
value = 1

[State 5210, gravity]
type = gravity
trigger1 = time >= 4

[State 5210, land]
type = ChangeState
trigger1 = vel y >= 0
trigger1 = pos y >= -ceil(vel y)
value = 52



; Pushed in the back
;-------------------

[Statedef 5320]
Type = S
MoveType = H
Physics = N
sprpriority = 1
velset = 0,0
ctrl = 0

[State 5320, SS chars animation]
type = ChangeAnim
trigger1 = time = 0
trigger1 = SelfAnimExist(5320)
value = 5320

[State 5320, other chars animation]
type = ChangeAnim
trigger1 = !SelfAnimExist(5320)
value = 5007

[State 5320, velocity 1]
type = VelSet
trigger1 = time = [5, 9]
x = 2.75

[State 5320, velocity 2]
type = VelSet
trigger1 = time = [10, 15]
x = 2.6

[State 5320, velocity 3]
type = VelSet
trigger1 = time = [16, 22]
x = 2

[State 5320, velocity 4]
type = VelSet
trigger1 = time = [23, 29]
x = 1.65

[State 5320, velocity 5]
type = VelSet
trigger1 = time = [30, 34]
x = 1.25

[State 5320, velocity 6]
type = VelSet
trigger1 = time = [35, 39]
x = 1

[State 5320, velocity 7]
type = VelSet
trigger1 = time = [40, 43]
x = 0.6

[State 5320, velocity 8]
type = VelSet
trigger1 = time = 44
x = 0

[State 5320, dust]
type = MakeDust
trigger1 = !SelfAnimExist(5320)
trigger1 = vel x != 0
pos = 0, 0
spacing = 3

[state 5320, brake sound]
type = PlaySnd
trigger1 = !SelfAnimExist(5320)
trigger1 = time = 1
value = 100, 4
channel = 1

[State 5320, end state]
type = SelfState
trigger1 = time = 47
value = 0
ctrl = 1



; Pushed in the stomach
;----------------------

[Statedef 5325]
Type = S
MoveType = H
Physics = N
sprpriority = 1
velset = 0,0
ctrl = 0

[State 5325, SS chars animation]
type = ChangeAnim
trigger1 = time = 0
trigger1 = SelfAnimExist(5325)
value = 5325

[State 5325, other chars animation]
type = ChangeAnim
trigger1 = !SelfAnimExist(5325)
value = 5017

[State 5325, velocity 1]
type = VelSet
trigger1 = time = [10, 24]
x = -2.5

[State 5325, velocity 2]
type = VelSet
trigger1 = time = [25, 33]
x = -1.6

[State 5325, velocity 3]
type = VelSet
trigger1 = time = [34, 42]
x = -1.3

[State 5325, velocity 4]
type = VelSet
trigger1 = time = [43, 49]
x = -1

[State 5325, velocity 5]
type = VelSet
trigger1 = time = 50
x = 0

[State 5325, dust]
type = MakeDust
trigger1 = !SelfAnimExist(5325)
trigger1 = vel x != 0
pos = 0, 0
spacing = 3

[state 5325, brake sound]
type = PlaySnd
trigger1 = !SelfAnimExist(5325)
trigger1 = time = 1
value = 100, 4
channel = 1

[State 5325, end state]
type = SelfState
trigger1 = time = 52
value = 0
ctrl = 1



; Dizzy Code by Ragnarok
;-----------------------

[Statedef 9000]
type = S
physics = S
movetype = H
ctrl = 0

[State 9000, Change Animation]
type = ChangeAnim
trigger1 = Time = 0
value = 5300

[State 9000, Button Jam]
type = ChangeState
triggerall = Random <= 500
trigger1 = (command = "a") || (command = "b") || (command = "c") 
trigger2 = (command = "x") || (command = "y") || (command = "z")
value = 9001

[State 9000, Next]
type = ChangeState
trigger1 = Time = 30
value = 9001

; Next Part
;----------

[Statedef 9001]
type = S
physics = S
movetype = H
ctrl = 0

[State 9001, Flash]
type = PalFX
trigger1 = Time = 0
time = 2
add = 50,50,50
mul = 300,300,300

[State 9001, Button Jam]
type = ChangeState
triggerall = Random <= 500
trigger1 = (command = "a") || (command = "b") || (command = "c") 
trigger2 = (command = "x") || (command = "y") || (command = "z")
value = 9002

[State 9001, Next]
type = ChangeState
trigger1 = Time = 30
value = 9002

; Next Part
;----------

[Statedef 9002]
type = S
physics = S
movetype = H
ctrl = 0

[State 9002, Flash]
type = PalFX
trigger1 = Time = 0
time = 2
add = 50,50,50
mul = 300,300,300

[State 9002, Button Jam]
type = ChangeState
triggerall = Random <= 500
trigger1 = (command = "a") || (command = "b") || (command = "c") 
trigger2 = (command = "x") || (command = "y") || (command = "z")
value = 9003

[State 9002, Next]
type = ChangeState
trigger1 = Time = 30
value = 9003

; Next Part
;----------

[Statedef 9003]
type = S
physics = S
movetype = H
ctrl = 0

[State 9003, Flash]
type = PalFX
trigger1 = Time = 0
time = 2
add = 50,50,50
mul = 300,300,300

[State 9003, Button Jam]
type = ChangeState
triggerall = Random <= 500
trigger1 = (command = "a") || (command = "b") || (command = "c") 
trigger2 = (command = "x") || (command = "y") || (command = "z")
value = 9004

[State 9003, Next]
type = ChangeState
trigger1 = Time = 30
value = 9004

; Next Part
;----------

[Statedef 9004]
type = S
physics = S
movetype = H
ctrl = 0

[State 9004, Flash]
type = PalFX
trigger1 = Time = 0
time = 2
add = 50,50,50
mul = 300,300,300

[State 9004, Button Jam]
type = ChangeState
triggerall = Random <= 500
trigger1 = (command = "a") || (command = "b") || (command = "c") 
trigger2 = (command = "x") || (command = "y") || (command = "z")
value = 9005

[State 9004, Next]
type = ChangeState
trigger1 = Time = 30
value = 9005

; Next Part
;----------

[Statedef 9005]
type = S
physics = S
movetype = H
ctrl = 0

[State 9005, Flash]
type = PalFX
trigger1 = Time = 0
time = 2
add = 50,50,50
mul = 300,300,300

[State 9005, Button Jam]
type = ChangeState
triggerall = Random <= 500
trigger1 = (command = "a") || (command = "b") || (command = "c") 
trigger2 = (command = "x") || (command = "y") || (command = "z")
value = 9006

[State 9005, Next]
type = ChangeState
trigger1 = Time = 30
value = 9006

; Next Part
;----------

[Statedef 9006]
type = S
physics = S
movetype = H
ctrl = 0

[State 9006, Flash]
type = PalFX
trigger1 = Time = 0
time = 2
add = 50,50,50
mul = 300,300,300

[State 9006, Button Jam]
type = ChangeState
triggerall = Random <= 500
trigger1 = (command = "a") || (command = "b") || (command = "c") 
trigger2 = (command = "x") || (command = "y") || (command = "z")
value = 9007

[State 9006, Next]
type = ChangeState
trigger1 = Time = 30
value = 9007

; Next Part
;----------

[Statedef 9007]
type = S
physics = S
movetype = H
ctrl = 0

[State 9007, Flash]
type = PalFX
trigger1 = Time = 0
time = 2
add = 50,50,50
mul = 300,300,300

[State 9007, Button Jam]
type = ChangeState
triggerall = Random <= 500
trigger1 = (command = "a") || (command = "b") || (command = "c") 
trigger2 = (command = "x") || (command = "y") || (command = "z")
value = 0

[State 9007, Undizzy]
type = SelfState
trigger1 = Time = 30
ctrl = 1
value = 0

; Self Dizzy
;----------

[Statedef 9010]
type = U
movetype = H
physics = N
ctrl = 0

[State 9010, Can't Hit]
type = NotHitBy
trigger1 = 1
value = SCA

[State 9010, Clear Stun]
type = VarSet
trigger1 = Time = 0
v = 7
value = 0

[State 9010, Fall]
type = ChangeState
trigger1 = HitShakeOver
value = 9000 + 11*(StateType = A)

; Fall
;-----

[Statedef 9011]
type = A
movetype = H
physics = N
velset = -3, -4
ctrl = 0
anim = 5050

[State 9011, Grav]
type = VelAdd
trigger1 = Pos Y < 0
y = 0.35

[State 9011, Can't Hit]
type = NotHitBy
trigger1 = 1
value = SCA

[State 9011, Fall]
type = ChangeState
trigger1 = (Pos Y >= 0) && (Vel Y > 0)
value = 9012

; Ground/Getup
;-------------

[Statedef 9012]
type = S
movetype = H
physics = S
ctrl = 0
anim = 5110

[State 9012, Stop Falling]
type = VelSet
trigger1 = Time = 0
Y = 0

[State 9012, Can't Hit]
type = NotHitBy
trigger1 = 1
value = SCA

[State 9012, Get Up]
type = ChangeAnim
trigger1 = Time = 25
value = 5120

[State 9012, Dizzy]
type = ChangeState
trigger1 = (AnimTime = 0) && (Anim = 5120)
value = 9000



; Guard Crush Code by Omniscience
;--------------------------------

[Statedef 9030]
type = U
movetype = H
physics = U
ctrl = 0

[State 9030, Animation]
type = ChangeAnim
trigger1 = Time = 0
value = 295 + 200*(StateType = C)

[State 9030, VarSet]
type = VarSet
trigger1 = Time = 0
v = 8
value = 0

[State 9030, NotHitBy]
type = NotHitBy
trigger1 = Time < 10
value = SCA

[State 9030, VelSet]
type = VelSet
trigger1 = Time = 0
x = -5

[State 9030, ChangeState]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1
